#include <nostub.h>
#include <graph.h>
#include <kbd.h>
#include <printf.h>
#include <alloc.h>
#include <ctype.h>
#include <dialogs.h>
#include <peekpoke.h>

int _ti89,_ti92plus;      //compile for a TI-89 and TI-92+

//define functions
void DrawEverything(void);

static unsigned int rand_seed=0; // seed for random numbers (NOT WRITTEN BY ME)

// each of these variables stores the total value of all rolls of each die
int two=0;
int three=0;
int four=0;
int six=0;
int eight=0;
int ten=0;
int twelve=0;
int twenty=0;
int hundred=0; 

//each of these variables stores how many times each die has been rolled
int two_r=0;
int three_r=0;
int four_r=0;
int six_r=0;
int eight_r=0;
int ten_r=0;
int twelve_r=0;
int twenty_r=0;
int hundred_r=0;

int rolled=0; //stores what was rolled last

int key_pressed=0;  //stores which key was pressed

//	THIS FUNCTION WAS NOT WRITTEN BY ME
int random(int x)                // returns a random number between 0 and x-1
{
  return (rand_seed=(75*rand_seed+1))%x;
}

void _main(void)  //this is where program execution begins
{
  LCD_BUFFER buffer;  //create a buffer to store screen information
  static WIN_RECT rect={0,0,100,14}; //I have no idea what this does :)
  LCD_save(buffer);   //save what's on the screen in the buffer
  while (key_pressed!=264) //keep going until ESC is pressed
  {
    key_pressed = 0;               //reset key_pressed variable
    ClrScr();                      //clear the screen
    if (rolled > 0) //if a number has been rolled
    {
      FontSetSys(F_8x10);  //set the font to the largest one
      printf_xy(100,50,"%d",rolled); //display what was rolled
      rolled = 0; //reset rolled variable
    }
    DrawEverything();              //draw all the stuff onto the screen
    key_pressed = ngetchx();       //wait for a keypress and store it in key_pressed
    rand_seed=137*peek(0x600017);  // pick the seed from the timer (NOT WRITTEN BY ME)
    if (key_pressed == 50)   //if the "2" key was pressed...
    {
	rolled = random(2)+1; //get random number between 1 and 2
	// add to the d2 variables
	two+=rolled;
	two_r++;
    }
    else if (key_pressed == 51)   //if the "3" key was pressed...
    {
	rolled = random(3)+1; //get random number between 1 and 3
	// add to the d3 variables
	three+=rolled;
	three_r++;
    }
    else if (key_pressed == 52)   //if the "4" key was pressed...
    {
	rolled = random(4)+1; //get random number between 1 and 4
	// add to the d4 variables
	four+=rolled;
	four_r++;
    }
    else if (key_pressed == 54)   //if the "6" key was pressed...
    {
	rolled = random(6)+1; //get random number between 1 and 6
	// add to the d6 variables
	six+=rolled;
	six_r++;
    }
    else if (key_pressed == 56)   //if the "8" key was pressed...
    {
	rolled = random(8)+1; //get random number between 1 and 8
	// add to the d8 variables
	eight+=rolled;
	eight_r++;
    }
    else if (key_pressed == 47)   //if the divide key was pressed...
    {
	rolled = random(10)+1; //get random number between 1 and 10
	// add to the d10 variables
	ten+=rolled;
	ten_r++;
    }
    else if (key_pressed == 42)   //if the multiply key was pressed...
    {
	rolled = random(12)+1; //get random number between 1 and 12
	// add to the d12 variables
	twelve+=rolled;
	twelve_r++;
    }
    else if (key_pressed == 45)   //if the minus key was pressed...
    {
	rolled = random(20)+1; //get random number between 1 and 20
	// add to the d20 variables
	twenty+=rolled;
	twenty_r++;
    }
    else if (key_pressed == 43)   //if the plus key was pressed...
    {
	rolled = random(100)+1; //get random number between 1 and 100
	// add to the d100 variables
	hundred+=rolled;
	hundred_r++;
    }
    else if (key_pressed == 263)   //if "CLEAR" was pressed...
    {
 	//reset all dice variables
	two=0;three=0;four=0;six=0;eight=0;ten=0;twelve=0;twenty=0;hundred=0;
	two_r=0;three_r=0;four_r=0;six_r=0;eight_r=0;ten_r=0;twelve_r=0;twenty_r=0;
	hundred_r=0;
    }
  }
  key_pressed = 0;    //reset key_pressed variable
  LCD_restore(buffer);//redraw the screen stored in buffer
}

void DrawEverything(void)  //draw information on the screen
{
  FontSetSys(F_4x6);  //set the font to the tiniest one
  printf_xy(3,3,"d2 (2) %d/%d",two,two_r);
  printf_xy(3,11,"d3 (3) %d/%d",three,three_r);
  printf_xy(3,19,"d4 (4) %d/%d",four,four_r);
  printf_xy(3,27,"d6 (6) %d/%d",six,six_r);
  printf_xy(3,35,"d8 (8) %d/%d",eight,eight_r);
  printf_xy(3,43,"d10 (/) %d/%d",ten,ten_r);
  printf_xy(3,51,"d12 (*) %d/%d",twelve,twelve_r);
  printf_xy(3,59,"d20 (-) %d/%d",twenty,twenty_r);
  printf_xy(3,67,"d100 (+) %d/%d",hundred,hundred_r);
  printf_xy(3,77,"Total: %d/%d",two+three+four+six+eight+ten+twelve+twenty+hundred,two_r+three_r+four_r+six_r+eight_r+ten_r+twelve_r+twenty_r+hundred_r);
  printf_xy(3,87,"Press CLEAR to erase all results.");
}